/*
 * CDDL HEADER START
 *
 * The contents of this file are subject to the terms of the
 * Common Development and Distribution License (the "License").
 * You may not use this file except in compliance with the License.
 *
 * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
 * or http://www.opensolaris.org/os/licensing.
 * See the License for the specific language governing permissions
 * and limitations under the License.
 *
 * When distributing Covered Code, include this CDDL HEADER in each
 * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
 * If applicable, add the following below this CDDL HEADER, with the
 * fields enclosed by brackets "[]" replaced with your own identifying
 * information: Portions Copyright [yyyy] [name of copyright owner]
 *
 * CDDL HEADER END
 */
/*
 * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
 * Use is subject to license terms.
 */

/*
 * Copyright (c) 2014 by Delphix. All rights reserved.
 */

/*
 * This is an entry point for kernel and user space.
 * This file is used in kernel compilation and in system
 * headers which need AVL tree data structures.
 * Those structures are also defined in libsunavl.h,
 * so to avoid conflicts we use guards here and in libsunavl.h
 */

#ifndef	_SYS_AVL_H
#define	_SYS_AVL_H

#ifndef _AVL_DATA_DEFINED
# define _AVL_DATA_DEFINED
# include <sys/avl_data.h>
#endif /* ! _AVL_DATA_DEFINED */

#ifdef _KERNEL
# include <sys/avl_kernel.h>
#endif /* _KERNEL */
 
#endif	/* ! _SYS_AVL_H */
